if not Watcher then return end

if select(2, UnitClass('player')) ~= "DRUID" then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants



C["Mangle"], _, C["Mangle Icon"] = GetSpellInfo(33876)
C["Rake"], _, C["Rake Icon"] = GetSpellInfo(48574)
C["Rip"], _, C["Rip Icon"] = GetSpellInfo(49800)
C["Ferocious Bite"], _, C["Ferocious Bite Icon"] = GetSpellInfo(48577)
C["Moonfire"], _, C["Moonfire Icon"] = GetSpellInfo(48463)
C["Ferocious Bite"], _, C["Ferocious Bite Icon"] = GetSpellInfo(48577)
C["Savage Roar"], _, C["Savage Roar Icon"] = GetSpellInfo(52610)
C["Claw"], _, C["Claw Icon"] = GetSpellInfo(48570)
C["Shred"], _, C["Shred Icon"] = GetSpellInfo(48572)

C["Faerie Fire"], _,C["Faerie Fire Icon"] = GetSpellInfo(16857)

function Watcher:SRInfo()
local index = 1
	while UnitBuff("player", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitBuff("player", index)
		if name == C["Savage Roar"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

function Watcher:RakeInfo()
local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
		if name == C["Rake"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

function Watcher:RipInfo()
local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
		if name == C["Rip"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

function Watcher:FFFInfo()
local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
		if name == C["Faerie Fire"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

function Watcher:MangleInfo()
local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
		if name == C["Mangle"] then 
			return debuffExpires - GetTime(), 0
		end
		index = index + 1
	end
	return 0, 0
end	

Watcher.priorityTable.name["Savage Roar"] = C["Savage Roar"]
Watcher.priorityTable.icon["Savage Roar"] = C["Savage Roar Icon"]
Watcher.priorityTable.check["Savage Roar"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:SRInfo(), false, 0, 1, C["Savage Roar"], 0, 0, 0, Watcher.db.char.druid.srcombo) 
	end
	
Watcher.priorityTable.name["Rake"] = C["Rake"]
Watcher.priorityTable.icon["Rake"] = C["Rake Icon"]
Watcher.priorityTable.check["Rake"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:RakeInfo(), false, 0, 1, C["Rake"], 0, 0, 0, 0 ) 
	end	
	
Watcher.priorityTable.name["Faerie Fire"] = C["Faerie Fire"]
Watcher.priorityTable.icon["Faerie Fire"] = C["Faerie Fire Icon"]
Watcher.priorityTable.check["Faerie Fire"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:FFFInfo(), false, 0, 1, C["Faerie Fire"].."()", 0, 0, 0, 0) 
	end	
	
Watcher.priorityTable.name["Rip"] = C["Rip"]
Watcher.priorityTable.icon["Rip"] = C["Rip Icon"]
Watcher.priorityTable.check["Rip"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:RipInfo(), false, 0, 1, C["Rip"], 0, 0, 0, Watcher.db.char.druid.ripcombo) 
	end	
	
Watcher.priorityTable.name["Claw"] = C["Claw"]
Watcher.priorityTable.icon["Claw"] = C["Claw Icon"]
Watcher.priorityTable.check["Claw"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Claw"], 0, 0, 0, 0) 
	end	
	
Watcher.priorityTable.name["Shred"] = C["Shred"]
Watcher.priorityTable.icon["Shred"] = C["Shred Icon"]
Watcher.priorityTable.check["Shred"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Shred"], 0, 0, 0, 0) 
	end	
	
Watcher.priorityTable.name["Ferocious Bite"] = C["Ferocious Bite"]
Watcher.priorityTable.icon["Ferocious Bite"] = C["Ferocious Bite Icon"]
Watcher.priorityTable.check["Ferocious Bite"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Ferocious Bite"], 0, 0, 0, Watcher.db.char.druid.fbcombo) 
	end	
	
Watcher.priorityTable.name["Mangle"] = C["Mangle"]
Watcher.priorityTable.icon["Mangle"] = C["Mangle Icon"]
Watcher.priorityTable.check["Mangle"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, false, 0, false, 0, 1, C["Mangle"].."()", 0, 0, 0, 0) 
	end	
	
Watcher.priorityTable.name["Mang"] = C["Mangle"].."DOT"
Watcher.priorityTable.icon["Mang"] = C["Mangle Icon"]
Watcher.priorityTable.check["Mang"] =  
	function (FrameName, optionnum) 	
		Watcher:UpdateSpell(FrameName, optionnum, true, Watcher:MangleInfo(), false, 0, 1, C["Mangle"].."()", 0, 0, 0, 0) 
	end		
	
		
Watcher.priorityTable.name["gcd"] = C["Moonfire"]
Watcher.priorityTable.icon["gcd"] = C["Moonfire Icon"]
Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Moonfire"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveIcon(FrameName, timeleft, optionnum)
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			return
		end
		if start == 0 then
			FrameName.Text:Hide()
			FrameName:SetAlpha(0)
		else
			FrameName.Text:Show()
		end
	end 